/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.PeriodoVacacional;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPeriodoVacacional;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Rafius
 */
@Controller("busquedaPeriodoVacacionalController")
@Scope("prototype")
public class BusquedaPeriodoVacacionalController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<PeriodoVacacional> plwPeriodoVacacional;
    private MyListbox periodoVacacionalList;
    private Paging pagingPeriodoVacacional;
    private Datebox fecInicio;
    private Datebox fecFinal;

    public Paging getPagingPeriodoVacacional() {
        return pagingPeriodoVacacional;
    }

    public void setPagingPeriodoVacacional(Paging pagingPeriodoVacacional) {
        this.pagingPeriodoVacacional = pagingPeriodoVacacional;
    }

    public MyListbox getPeriodoVacacionalList() {
        return periodoVacacionalList;
    }

    public void setPeriodoVacacionalList(MyListbox periodoVacacionalList) {
        this.periodoVacacionalList = periodoVacacionalList;
    }

    public PagedListWrapper<PeriodoVacacional> getPlwPeriodoVacacional() {
        return plwPeriodoVacacional;
    }

    public void setPlwPeriodoVacacional(PagedListWrapper<PeriodoVacacional> plwPeriodoVacacional) {
        this.plwPeriodoVacacional = plwPeriodoVacacional;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        if (fecInicio.getValue() != null && fecFinal.getValue() != null) {
            if (fecInicio.getValue().after(fecFinal.getValue())) {
                Messagebox.show(
                        Labels.getLabel("editarPeriodoVacacionalController.MSG.busquedaPeriodo"),
                        Labels.getLabel("editarPeriodoVacacionalController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } else {
                refreshLista();
            }
        } else {
            refreshLista();
        }

        refreshLista();

        fecInicio.focus();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new PeriodoVacacional());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        periodoVacacionalList.setItemRenderer(new RenderPeriodoVacacional());
        periodoVacacionalList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                PeriodoVacacional pv = (PeriodoVacacional) periodoVacacionalList.getSelected();
                verPeriodo(pv);
            }
        });

        refreshLista();
    }

    private void verPeriodo(PeriodoVacacional pv) {
        if (pv == null) {
            return;
        }

        Map args = new HashMap();
        args.put("periodoVacacional", pv);
        args.put("periodoVacacionalList", periodoVacacionalList);

        openWindow("/gui/configuraciones_comerciales/editarPeriodoVacacional.zul",
                Labels.getLabel("editarPeriodoVacacionalController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<PeriodoVacacional> claseServicioBusqueda =
                new HibernateSearchObject<PeriodoVacacional>(PeriodoVacacional.class, pagingPeriodoVacacional.getPageSize());
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);

        if (fecInicio.getValue() != null) {
            claseServicioBusqueda.addFilterGreaterOrEqual("fecinicio", fecInicio.getValue());
        }
        if (fecFinal.getValue() != null) {
            claseServicioBusqueda.addFilterLessOrEqual("fecfinal", fecFinal.getValue());
        }

        claseServicioBusqueda.addSortAsc("fecinicio");

        plwPeriodoVacacional.init(claseServicioBusqueda, periodoVacacionalList, pagingPeriodoVacacional);

        if (periodoVacacionalList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaPeriodoVacacionalController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
